#include <fstream>
#include <cstdio>
#include "minunit.h"
#include "mmapfile.hpp"

int tests_run = 0;

using namespace std;

char* test_mmapfile() {
    char* tmpfile = tmpnam(0);
    ofstream of(tmpfile, ios::binary);
    for (size_t i = 0;i < 100; ++i)
        of.write((const char*)&i, sizeof(i));
    of.close();

    MmapFile fm(tmpfile, "r", 0);
    mu_assert(fm.open() == true);
    mu_assert(fm.size() == 100ul*sizeof(size_t));

    size_t* p = (size_t*)fm.addr();
    for (size_t i = 0;i < 100; ++i)
        mu_assert(*p++ == i);
    mu_assert(remove(tmpfile) == 0);
    return 0;
}


static char * all_tests() {
    mu_run_test(test_mmapfile);
    return 0;
}

int main(int argc, char **argv) {
    char *result = all_tests();
    if (result != 0) {
        printf("%s\n", result);
    }
    else {
        printf("ALL TESTS PASSED\n");
    }
    printf("Tests run: %d\n", tests_run);

    return result != 0;
}

